<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Chapter 5: Pointers and Arrays</title>
<link href="sx7n.html" rev=precedes>
<link href="sx8a.html" rel=precedes>
<link href="top.html" rev=subdocument>
</head>
<body>
<H1>Chapter 5: Pointers and Arrays</H1>

<p>page 93
</p><p>Pointers are often thought to be the most difficult aspect of C.
It's true that many people have various problems with pointers,
and that many programs founder on pointer-related bugs.
Actually,
though,
many of the problems are not so much with the pointers <I>per se</I>
but rather with the memory they point to,
and more specifically,
when there <em>isn't</em> any valid memory which they point to.
As long as you're careful to ensure that the pointers in your 
programs always point to valid memory,
pointers can be useful, powerful, and relatively trouble-free tools.
(In these notes,
we'll be emphasizing techniques for ensuring that pointers 
always point where they should.)
</p><p>If you haven't worked with pointers before,
they're bound to be a bit baffling at first.
Rather than attempting a complete definition
(which probably wouldn't mean anything, either)
up front,
I'll ask you to read along for a few pages,
withholding judgment,
and after we've seen a few of the things that pointers can <em>do</em>, 
we'll be in a better position to appreciate what they <em>are</em>.
</p><p><a href="sx8a.html" rel=subdocument>section 5.1: Pointers and Addresses</a></p>
<p><a href="sx8b.html" rel=subdocument>section 5.2: Pointers and Function Arguments</a></p>
<p><a href="sx8c.html" rel=subdocument>section 5.3: Pointers and Arrays</a></p>
<p><a href="sx8d.html" rel=subdocument>section 5.4: Address Arithmetic</a></p>
<p><a href="sx8e.html" rel=subdocument>section 5.5: Character Pointers and Functions</a></p>
<p><a href="sx8f.html" rel=subdocument>section 5.6: Pointer Arrays; Pointers to Pointers</a></p>
<p><a href="sx8g.html" rel=subdocument>section 5.7: Multi-dimensional Arrays</a></p>
<p><a href="sx8h.html" rel=subdocument>section 5.8: Initialization of Pointer Arrays</a></p>
<p><a href="sx8i.html" rel=subdocument>section 5.9: Pointers vs. Multi-dimensional Arrays</a></p>
<p><a href="sx8j.html" rel=subdocument>section 5.10: Command-line Arguments</a></p>
<hr>
<p>
Read sequentially:
<a href="sx7n.html" rev=precedes>prev</a>
<a href="sx8a.html" rel=precedes>next</a>
<a href="top.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
